/*******************************************************************************
Title:      FastSearch
Version:    V0.0.0
Date:       28.01.2013
Author:     bestucki
IDE:        Dev-C++ V4.9.9.2
Licence:    GNU GENERAL PUBLIC LICENSE, Version 3, 29 June 2007

            Copyright 2013 bestucki

            This program is free software: you can redistribute it and/or modify
            it under the terms of the GNU General Public License as published by
            the Free Software Foundation, either version 3 of the License, or
            (at your option) any later version.

            This program is distributed in the hope that it will be useful, but
            WITHOUT ANY WARRANTY; without even the implied warranty of
            MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
            General Public License for more details.

            You should have received a copy of the GNU General Public License
            along with this program.  If not, see
            <http://www.gnu.org/licenses/>.

*******************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <dirent.h>
#include <string.h>
#include <ctype.h>

#define STRINGSIZE_SEARCH 65
#define STRINGSIZE_DIR 257

unsigned long long int result_counter=0;

char* strtoupper(char *s)
{
  unsigned int i;
  for(i=0;s[i]!='\0';i++)
    s[i]=toupper(s[i]);
  return s;
}

int listdir(char *directory, char *searchtext)
{
  char directory2[STRINGSIZE_DIR]="";
  struct dirent *entry;
  DIR *dp;
  dp=opendir(directory);
  if(dp==NULL)
    return -1;
  while(entry=readdir(dp))
  {
    if(strcmp(entry->d_name,".")&&strcmp(entry->d_name,"..")&&strchr(entry->d_name,'%')==NULL)
    {
      strcpy(directory2,directory);
      strcat(directory2,"\\");
      strcat(directory2,entry->d_name);
      if(strstr(strtoupper(entry->d_name),searchtext))
      {
        printf("%s\n",directory2);
        result_counter++;
      }
      listdir(directory2,searchtext);
      directory2[0]='\0';
    }
  }
  closedir(dp);
  return 0;
}

int strreplace(char *s, char c_old, char c_new)
{
  unsigned int i;
  for(i=0;s[i]!=c_old;i++)
    if(s[i]=='\0')
      return -1;
  s[i]=c_new;
  return 0;
}

int main(int argc, char *argv[])
{
  char searchtext[STRINGSIZE_SEARCH]="";
  char directory[STRINGSIZE_DIR]="";
  unsigned int i;

  printf("FastSearch V0.0.0\n\n\n");

  printf("Suchbegriff eingeben:\n");
  rewind(stdin);
  fgets(searchtext,STRINGSIZE_SEARCH-1,stdin);
  strreplace(searchtext,'\n','\0');
  strtoupper(searchtext);

  printf("\nSuchpfad eingeben (ohne \\ am Ende, ausser bei Laufwerknamen):\n");
  printf("Bemerkung: Pfade, die ein %% enthalten, werden von der Suche ausgeschlossen!\n");
  rewind(stdin);
  fgets(directory,STRINGSIZE_DIR-1,stdin);
  strreplace(directory,'\n','\0');

  printf("\n\nSuchergebnisse:\n\n");
  if(listdir(directory,searchtext)<0)
    printf("\n\nUngueltiger Pfad");
  else
  {
    printf("\n\nSuche abgeschlossen!\n");
    printf("Gefundene Objekte: %u",result_counter);
  }
  printf("\n\n");

  system("PAUSE");
  return 0;
}

/* End of file */
